/**
 * Yumpu-Player Script
 * @author Roberto Cornice <cornice@lemm.de> * 
 * @returns {LemmYumpu}
 */
function LemmYumpu()	{
	var me = this;
	
	this.fsId;
	this.myYumpu;
	
	/**
	 * Initialize by getting the Yumpu-JS first and then binding the onclicks
	 */
	this.init	= function(){
		jQuery.getScript("https://players.yumpu.com/hub.js", function()	{
			me.myYumpu = new Yumpu();
			me.fsId	= "yumpuPlayerOverlay_"+jQuery.now();
			jQuery(".tx_lemmyumpu .yumpu_element").css("cursor","pointer").on("click", function(event)	{
				event.preventDefault();
				me.createFullScreenContainer( jQuery(this) );
			});
		});
	};
	
	/**
	 * Sets all the fullscreen links
	 */
	this.setFullScreen	= function()	{
		var elem = document.getElementById(me.fsId);
		if (elem.requestFullscreen) {
			elem.requestFullscreen();
		} else if (elem.mozRequestFullScreen) {
			elem.mozRequestFullScreen();
		} else if (elem.webkitRequestFullscreen) {
			elem.webkitRequestFullscreen();
		}
		jQuery(document).off("webkitfullscreenchange mozfullscreenchange fullscreenchange").on("webkitfullscreenchange mozfullscreenchange fullscreenchange", function(e) {
			var state = document.fullScreen || document.mozFullScreen || document.webkitIsFullScreen;
			if( typeof state === "undefined" ||  state !== true )   {
				jQuery("#"+me.fsId).remove();
			}
		});	
	};
	
	/**
	 * creates the fullscreen container
	 * @returns {jQuery}
	 */
	this.createFullScreenContainer	= function( obj )	{
		jQuery("#"+me.fsId).remove();
		var fsContainer	= jQuery("<div></div>");
		jQuery(fsContainer).attr("id", me.fsId).css({
			position	: "fixed",
			top			: "0",
			left		: "0",
			width		: "100%",
			height		: "100%",
			margin		: "0",
			padding		: "0",
			opacity		: 1,
			background	: "#FFFFFF"
		});
		jQuery("body").append(jQuery(fsContainer));
		me.myYumpu.create_player("#"+me.fsId, jQuery(obj).attr("data-id"), {
			canvasBGColor   : "#808080", 
            canvasFSBGColor		: "#808080", 
            fallback_order		: "flash,html5,js",
            isFSOverlay			: "1",
            c2rText				: "",
			embedded			: true,
			lang				: "de"
			
		});
		me.setFullScreen();
		return jQuery(fsContainer);
	};
	
	me.init();
}

/**
 * Autostart
 */
var LemmYumpuObject;
if( typeof jQuery(document).ready === "function" )	{
	console.log("init.ready");
	jQuery(document).ready( function () {
		LemmYumpuObject = new LemmYumpu();
	});
} else {
	console.log("init.onReady");
	jQuery(document).on("ready", function () {
		LemmYumpuObject = new LemmYumpu();
	});
}