<?php
namespace Lemm\LemmYumpu\Tests\Unit\Controller;

/**
 * Test case.
 */
class YumpuControllerTest extends \TYPO3\CMS\Core\Tests\UnitTestCase
{
    /**
     * @var \Lemm\LemmYumpu\Controller\YumpuController
     */
    protected $subject = null;

    protected function setUp()
    {
        parent::setUp();
        $this->subject = $this->getMockBuilder(\Lemm\LemmYumpu\Controller\YumpuController::class)
            ->setMethods(['redirect', 'forward', 'addFlashMessage'])
            ->disableOriginalConstructor()
            ->getMock();
    }

    protected function tearDown()
    {
        parent::tearDown();
    }

    /**
     * @test
     */
    public function listActionFetchesAllYumpusFromRepositoryAndAssignsThemToView()
    {

        $allYumpus = $this->getMockBuilder(\TYPO3\CMS\Extbase\Persistence\ObjectStorage::class)
            ->disableOriginalConstructor()
            ->getMock();

        $yumpuRepository = $this->getMockBuilder(\::class)
            ->setMethods(['findAll'])
            ->disableOriginalConstructor()
            ->getMock();
        $yumpuRepository->expects(self::once())->method('findAll')->will(self::returnValue($allYumpus));
        $this->inject($this->subject, 'yumpuRepository', $yumpuRepository);

        $view = $this->getMockBuilder(\TYPO3\CMS\Extbase\Mvc\View\ViewInterface::class)->getMock();
        $view->expects(self::once())->method('assign')->with('yumpus', $allYumpus);
        $this->inject($this->subject, 'view', $view);

        $this->subject->listAction();
    }
}
